/*
 Copyright 2010 Andres Leonardo Martinez Ortiz

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
*/

import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStream;
import java.io.BufferedReader;
import java.io.InputStreamReader;

import java.util.Date;
import java.util.Map;
import java.util.Set;
import java.util.List;

import oauth.signpost.OAuthConsumer;
import oauth.signpost.basic.DefaultOAuthConsumer;
import oauth.signpost.signature.HmacSha1MessageSigner;

import java.net.URL;
import java.net.HttpURLConnection;

public class adAPIDemo {
    public static void main (String[] args) throws IOException{

        BufferedReader isReader = null;
        String apiDataInfo = "API-AccessToken.ini";
    
        String consumer_key;
        String consumer_secret;
        String apiAccessToken_key;
        String apiAccessToken_secret;
        String adSpace;

        OAuthConsumer apiConsumer = null;
    
        String szAdURLTemplate = "https://api.bluevia.com/services/REST/Advertising_Sandbox/simple/requests?version=v1";

        URL bvAdAPIURL = null;
        HttpURLConnection request = null;

        String szReqBody = null;
        int rc = 0;

        try{
            isReader = new BufferedReader ( new FileReader (apiDataInfo));
            consumer_key = isReader.readLine();
            consumer_secret = isReader.readLine();
            apiAccessToken_key = isReader.readLine();
            apiAccessToken_secret = isReader.readLine();            
            adSpace = isReader.readLine();
            
            apiConsumer = new DefaultOAuthConsumer(consumer_key,consumer_secret);
            apiConsumer.setMessageSigner(new HmacSha1MessageSigner());
            apiConsumer.setTokenWithSecret(apiAccessToken_key, apiAccessToken_secret); 
 
            Date now = new Date();

            bvAdAPIURL = new URL(szAdURLTemplate);
            request = (HttpURLConnection) bvAdAPIURL.openConnection();

            request.setDoOutput(true);
            request.setRequestMethod("POST");            

            apiConsumer.sign(request);

            szReqBody = String.format("\nad_request_id=%s\n",apiAccessToken_key+now.getTime());
            szReqBody += String.format("ad_presentation=0104&\n");//0104 (text) - 0101 (image) 
            szReqBody += String.format("ad_space=%s\n",adSpace+"&"); 
            szReqBody += String.format("user_agent=none\n"); 
            szReqBody += String.format("keywords=computer\n"); 
            szReqBody += String.format("protection_policy=2\n");//Values: Safe,Low,High 

            OutputStream os = request.getOutputStream();           
			os.write(szReqBody.getBytes()); 
			os.flush();

            request.connect();
	        rc = request.getResponseCode();
	        System.out.printf("%d : %s\n",rc ,request.getResponseMessage());

            if (rc == HttpURLConnection.HTTP_CREATED){
    
                StringBuffer doc = new StringBuffer();
			    BufferedReader br =null;
                String line = null;

                br = new BufferedReader(new InputStreamReader(request.getInputStream()));                
                line = br.readLine();
                
                while (line != null) {
            	    doc.append(line);
                    line = br.readLine();
                }
            
                System.out.printf("Output message: %s\n", doc.toString());
            }
	        
        }catch (Exception e){
            System.err.println(e.getMessage());
        }finally{
            if (isReader!=null)
                isReader.close();
        }
    }
}
