/*
 Copyright 2011 Andres Leonardo Martinez Ortiz

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
 */

import javax.swing.event.ChangeEvent;
import java.text.*;

import java.awt.*;

import java.io.FileReader;
import java.io.IOException;
import java.io.BufferedReader;

import oauth.signpost.OAuthConsumer;
import oauth.signpost.basic.DefaultOAuthConsumer;
import oauth.signpost.signature.HmacSha1MessageSigner;

/*
 * RevenueCalGUI.java
 *
 * Created on 08-feb-2011, 22:23:20
 */

/**
 *
 * @author almo
 */
public class moRevenueCalGUI extends javax.swing.JFrame {

    private BVSMSCollector _bvSMSCollector;

    /** Creates new form RevenueCalGUI */
    public moRevenueCalGUI(OAuthConsumer apiConsumer, String registrationID) {
        initComponents();
        _bvSMSCollector = new BVSMSCollector(this, apiConsumer, registrationID);
    }

    public void appendSMSLog(String smsLog){
        if (smsLog!=null)
            taSMSLog.append(smsLog+"\n");
    }

    public void setRevenue(double revenue){
        lblRevenueValue.setValue(revenue);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        lblRevenueText = new javax.swing.JLabel();
        lblRevenueValue = new javax.swing.JFormattedTextField(revenueFormat);
        lblCurrency = new javax.swing.JLabel();
        spSMSLog = new javax.swing.JScrollPane();
        taSMSLog = new javax.swing.JTextArea();
        btnStartStop = new javax.swing.JToggleButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("BlueVia Revenue Calculator");
        setResizable(false);

        lblRevenueText.setFont(new java.awt.Font("SansSerif", 1, 48));
        lblRevenueText.setText("Revenue:");

        lblRevenueValue.setFont(new java.awt.Font("SansSerif", 1, 48));
        lblRevenueValue.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        lblRevenueValue.setValue(0.0);
        lblRevenueValue.setInheritsPopupMenu(false);
        lblRevenueValue.setEditable(false);
        lblRevenueValue.setForeground(Color.green);

        revenueFormat = NumberFormat.getNumberInstance();
        revenueFormat.setMaximumFractionDigits(3);
        

        lblCurrency.setFont(new java.awt.Font("SansSerif", 1, 48));
        lblCurrency.setText("€");

        taSMSLog.setColumns(20);
        taSMSLog.setFont(new java.awt.Font("SansSerif", 1, 12)); // NOI18N
        taSMSLog.setRows(5);
        spSMSLog.setViewportView(taSMSLog);

        btnStartStop.setText("Start");
      
        btnStartStop.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnStartStopActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(spSMSLog, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 809, Short.MAX_VALUE)
                    .addComponent(btnStartStop)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(lblRevenueText)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(lblRevenueValue, javax.swing.GroupLayout.PREFERRED_SIZE, 224, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(lblCurrency)))
                .addContainerGap())
        );

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(lblRevenueText, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 58, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(lblRevenueValue, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(lblCurrency, javax.swing.GroupLayout.DEFAULT_SIZE, 58, Short.MAX_VALUE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(btnStartStop)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(spSMSLog, javax.swing.GroupLayout.PREFERRED_SIZE, 183, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnStartStopActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnStartStopActionPerformed
        // TODO add your handling code here:
        if (btnStartStop.getText().equals("Start")){
            btnStartStop.setText("Stop");
            if (!_bvSMSCollector.isAlive())
                _bvSMSCollector.start();
        }
        else{
            btnStartStop.setText("Start");
            btnStartStop.setEnabled(false);
            _bvSMSCollector.finish();
        }
    }//GEN-LAST:event_btnStartStopActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) throws IOException {

	BufferedReader iReader = null;
	String apiDataFile = "API-AccessToken.ini";
		
	String consumer_key;
	String consumer_secret;
	String apiAccessToken_key;
	String apiAccessToken_secret;

	try {

        iReader = new BufferedReader (new FileReader(apiDataFile));

		consumer_key = iReader.readLine();
       	consumer_secret= iReader.readLine();
		apiAccessToken_key = iReader.readLine();
		apiAccessToken_secret = iReader.readLine();
		final String registrationID = iReader.readLine();

		// Set up the oAuthConsumer
		final OAuthConsumer apiConsumer = new DefaultOAuthConsumer(consumer_key,consumer_secret);
		apiConsumer.setMessageSigner(new HmacSha1MessageSigner ());
		apiConsumer.setTokenWithSecret(apiAccessToken_key, apiAccessToken_secret);

       	java.awt.EventQueue.invokeLater(new Runnable() {
        	    public void run() {
        	        new moRevenueCalGUI(apiConsumer,registrationID).setVisible(true);
        	    }
       	});

	} catch (IOException e){
    	System.err.println(e.getMessage());			    
    }catch (Exception e){
		System.err.println(e.getMessage());			
	} finally {
		if (iReader!=null)
			iReader.close();
	}
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JToggleButton btnStartStop;
    private javax.swing.JLabel lblCurrency;
    private javax.swing.JLabel lblRevenueText;
    private javax.swing.JFormattedTextField lblRevenueValue;
    private javax.swing.JScrollPane spSMSLog;
    private javax.swing.JTextArea taSMSLog;
    private NumberFormat revenueFormat;
    // End of variables declaration//GEN-END:variables

}
