/*
   Copyright 2010 Andres Leonardo Martinez Ortiz

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License. 
*/

import java.io.FileReader;
import java.io.IOException;
import java.io.BufferedReader;
import java.io.InputStreamReader;

import java.net.URL;
import java.net.HttpURLConnection;

import oauth.signpost.OAuthConsumer;
import oauth.signpost.basic.DefaultOAuthConsumer;
import oauth.signpost.signature.HmacSha1MessageSigner;

public class userCtxtDemo {
  
  public static void main (String [] args) throws IOException {
    BufferedReader isReader = null;
    String apiDataFile = "API-AccessToken.ini";
    
    String consumer_key;
    String consumer_secret;
    String apiAccessToken_key;
    String apiAccessToken_secret;

    OAuthConsumer apiConsumer = null;

    String szUsrCtxtTemplate = "https://api.bluevia.com/services/REST/Directory/alias:%s/UserInfo?version=v1&alt=json";

    URL bvUsrCtxtURL = null;
    HttpURLConnection request = null;
    int rc = 0;

    try {
        isReader = new BufferedReader (new FileReader (apiDataFile));
        consumer_key = isReader.readLine();
        consumer_secret = isReader.readLine();
        apiAccessToken_key = isReader.readLine();
        apiAccessToken_secret = isReader.readLine();

        apiConsumer = new DefaultOAuthConsumer (consumer_key, consumer_secret);
        apiConsumer.setMessageSigner(new HmacSha1MessageSigner());
        apiConsumer.setTokenWithSecret(apiAccessToken_key, apiAccessToken_secret);

        bvUsrCtxtURL = new URL(String.format(szUsrCtxtTemplate,apiAccessToken_key));
        
        request = (HttpURLConnection) bvUsrCtxtURL.openConnection();
        request.setRequestMethod("GET"); 
        
        apiConsumer.sign(request);

        BufferedReader br = null;
        StringBuffer response = new StringBuffer();
        String line;

        rc = request.getResponseCode();
        if (rc == HttpURLConnection.HTTP_OK)
            br = new BufferedReader ( new InputStreamReader (request.getInputStream()));
        else
            br = new BufferedReader ( new InputStreamReader (request.getErrorStream()));

        line = br.readLine();
        while (line != null) {
            response.append(line);
            line = br.readLine();
        }

        System.out.println(response.toString());

        request.disconnect();

    } catch (Exception e){
        System.err.println(e.getMessage());
    } finally {
        if (isReader!=null)
            isReader.close();
    }  
  }
}
