Keywords:			MultiMarkdown, Markdown, XML, XHTML, XSLT, PDF   
CSS:				css/print.css
CSS:  				css/doc-less.css


# Mastering BlueVia Low Level API #

BlueVia provides SDK's for several languages, but if you want to use BlueVia API's in another language, you have to deal with the low level API. This tutorial aims to explain this API and uses python as the programming language. The library that has been created during compilation of this tutorial might even be helpful for python developers as a starting point. 

The tutorial contains 5 parts:

[1 Preparing the Tools](python_tutorial_1.html) 
</br>&nbsp; &nbsp; 1.1 Get your BlueVia Test API Key
</br>&nbsp; &nbsp; 1.2 Get your Python environment prepared
	
[2 How to use BlueVia for Python](python_tutorial_2.html)
</br>&nbsp; &nbsp; 2.1 The BlueVia oAuth Dance
</br>&nbsp; &nbsp; 2.2 Example 1: Send SMS
</br>&nbsp; &nbsp; 2.3 Example 2: Get Terminal Location
</br>&nbsp; &nbsp; 2.4 Sample usage of all BlueVia python routines

[3 Implement BlueVia for Python - The oAuth Dance](python_tutorial_3.html)
</br>&nbsp;&nbsp;3.1 Creating correct and signed requests
</br>&nbsp;&nbsp;3.2 Get a Request Token
</br>&nbsp;&nbsp;3.3 Get a Access Token

[4 Implement BlueVia for Python - The APIs](python_tutorial_4.html)
</br>&nbsp;&nbsp;4.1 Send SMS
</br>&nbsp;&nbsp;4.2 Track SMS delivery
</br>&nbsp;&nbsp;4.3 Send MMS
</br>&nbsp;&nbsp;4.4 Track MMS delivery
</br>&nbsp;&nbsp;4.5 Receive SMS
</br>&nbsp;&nbsp;4.6 Receive MMS
</br>&nbsp;&nbsp;4.7 Retrieve MMS attachments
</br>&nbsp;&nbsp;4.8 Get the terminal location
</br>&nbsp;&nbsp;4.9 Get the user context
</br>&nbsp;&nbsp;4.10 Get advertisings - 3 legged oAuth
</br>&nbsp;&nbsp;4.11 Get advertisings - 2 legged oAuth
</br>&nbsp;&nbsp;4.12 Payments - Get Payment Token
</br>&nbsp;&nbsp;4.13 Payments - Issue Payment
</br>&nbsp;&nbsp;4.14 Payments - Check Payment Status

[5 Some tricks using BlueVia for Python](python_tutorial_5.html)
</br>&nbsp;&nbsp;5.1 Debugging BlueVia oAuth calls
</br>&nbsp;&nbsp;5.2 Some specifics of the BlueVia implementation


