Keywords:			MultiMarkdown, Markdown, XML, XHTML, XSLT, PDF   
CSS:				css/print.css
CSS:  				css/doc-less.css

<div class="nav">
<span class="lnav"><a href="python_tutorial.html">&lt; prev</a></span>&nbsp;&nbsp;
<span class="rnav"><a href="python_tutorial_2.html">next &gt;</a></span>
</div>

# 1 Preparing the Tools #
Before getting started, we need to prepare our development envrionment. This basically includes two steps:

- Getting a BlueVia Test API Key
- Setting up python (install oauth and json packages)

## 1.1 Get your BlueVia Test API Key ##
First of all you need to register with BlueVia, if you haven't already done - all you need is a username, a password an email address and (optionally if you want to make use of the real radio network) a mobile number of one of Telefónica´s mobile operators supporting BlueVia, see [API country availability](https://bluevia.com/en/knowledge/APIs.API-country-availability)

To be able to use BlueVia API's as a developer you then need to get a BlueVia Test API key. In oAuth terms, this includes the credentials (key and secret) of the _Consumer_. So, go to [Get your Test API key](https://bluevia.com/en/api-keys/get-test) and create your first application:

![Get Test API key](images/BlueviaGetYourTestAPIKeySmall.png "Create Test API key") [(Large version)](./images/BlueviaGetYourTestAPIKey.png)

The important fields are: 

- A unique name - you could use e.g. _com.{your domain}.{app name}_ 
- A simple description
- The BlueVia API's you want to use. For the purpose of the tutorial just check tick every single API
- A unique keyword that will be used to identify you as owner of an SMS/MMS sent to a shortcode (see [here](https://bluevia.com/en/knowledge/APIs.API-country-availability) in the middle of the page)

We won't use notifications to recieve SMS and MMS, so no X.509 key is necessary.

After you have submitted your data, you get the following:

![Test API key](images/BlueviaAppDetailsSmall.png "Create Test API key") [(Large version)](images/BlueviaAppDetails.png)

Let's go through the important parts:

1) Your API key is only valid for testing. If you want to publish your app you need to [apply](https://bluevia.com/en/knowledge/Commercialization) for a so called  _Commercial Key_

||
------------: | :--------: |
API key type: | *TESTING*  |

2) The oAuth Consumer Key and Secret to be used in oAuth requests to identify you as a developer.


||
----------: | :-------------------- |
Key:     	| *yT11072616762766*  |
Secret:  	| *hofF15263457*     |     


3) Your keywords for receiving SMS and MMS

As BlueVia supports two environments during developement of an application, there are two different keywords generated from the one you've given before:

||
------------------: | :------------: |
Test MO keyword:    | *TESTBWTUT01*  |
Sandbox MO keyword: | *SANDBWTUT01*  |     

The sandbox keyword (*SANDBWTUT01*) is used without any impact on a real radio network and the other one (*TESTBWTUT01*) can be used for testing purposes in the real radio network (free within your free credits)

4) Your advertising space id, necessary to show BlueVia Ads in your application

||
--------------------: | :------: |
Advertising Space id: | *10977*  |


## 1.2 Get your Python environment prepared ##

There is little to do with python. The tutorial has been prepared with Python 2.6. Further on we need three additional python modules:

- [httplib2](http://code.google.com/p/httplib2/): Makes life with http calls easier
- [oauth2](https://github.com/simplegeo/python-oauth2): The actual oauth library
- [simplejson](http://code.google.com/p/simplejson): Makes life with JSON easier

The easiest way to get these is *easy_install*  from python setup tools:

	easy_install httplib2
	easy_install oauth2
	easy_install simplejson

Now everything should be ready for the tutorial.

<div class="nav">
<span class="lnav"><a href="python_tutorial.html">&lt; prev</a></span>&nbsp;&nbsp;
<span class="rnav"><a href="python_tutorial_2.html">next &gt;</a></span>
</div>
</p>