#
# BlueVia is a global iniciative of Telefonica delivered by Movistar and O2.
# Please, check out www.bluevia.com and if you need more information
# contact us at mailto:support@bluevia.com

$:.unshift File.join(File.dirname(__FILE__),'..','lib')

require 'test/unit'
require 'bluevia'
require 'test_config'

class TestAdvertising < Test::Unit::TestCase
  include TestConfig
  def setup
    create_client(false, :Advertising)
  end

  def test_get_ad
    get_ad
  end

  def test_get_ad_fails
    get_ad_fails
  end

  def test_get_ad_commercial
    create_client(true, :Advertising)
    get_ad
  end

  def t_test_get_ad_commercial_fails
    create_client(true, :Advertising)
    get_ad_fails
  end

  private

  def get_ad
    params = {:user_agent => "Mozilla 5.0",
      :ad_request_id => "a1x4zasg58",
      :ad_space => "1200"
    }
    response = @service.request(params)

    assert_equal response.instance_of?(Bluevia::AdResponse), true
   
    response.each{|item|
      %w[value type_name interaction type_id].each{|key|
        assert_equal true, item.has_key?(key)
      }
    }

    assert_equal response.image.instance_of?(Hash), true

    assert_equal response.text.instance_of?(Hash), true

  end

  def get_ad_fails
    params = {:user_agent => "Mozilla 5.0",
      :ad_request_id => "a1x4zasg58w"
    }
    assert_raise Bluevia::ClientError do
      @service.request(params)
    end
  end
end
