#
# BlueVia is a global iniciative of Telefonica delivered by Movistar and O2.
# Please, check out www.bluevia.com and if you need more information
# contact us at mailto:support@bluevia.com

$:.unshift File.join(File.dirname(__FILE__),'..','lib')

require 'test/unit'
require 'bluevia'
require 'test_config'

#
# (c) Bluevia (mailto:support@bluevia.com)
#

class TestDirectory < Test::Unit::TestCase
  include Bluevia
  include TestConfig
  def setup
    create_client(false, :Directory)
  end

  def test_get_terminal_info
    get_terminal_info(TestConfig::SandBox::TOKEN)
  end

  def test_get_terminal_info_commercial
    create_client(true, :Directory)
    get_terminal_info(TestConfig::Commercial::TOKEN)
  end

  def test_get_access_info
    get_access_info(TestConfig::SandBox::TOKEN)
  end

  def test_get_access_info_commercial
    create_client(true, :Directory)
    get_access_info(TestConfig::Commercial::TOKEN)
  end

  def test_get_profile
    get_profile(TestConfig::SandBox::TOKEN)
  end

  def test_get_profile_commercial
    create_client(true, :Directory)
    get_profile(TestConfig::Commercial::TOKEN)
  end

  def test_get_two_values
    get_profile_access_info(TestConfig::SandBox::TOKEN)
  end

  def test_get_two_values_commercial
    create_client(true, :Directory)
    get_profile_access_info(TestConfig::Commercial::TOKEN)
  end

  def test_get_all_info
    get_all_info(TestConfig::SandBox::TOKEN)
  end

  def test_get_all_info_commercial
    create_client(true, :Directory)
    get_all_info(TestConfig::Commercial::TOKEN)
  end

  private

  def get_terminal_info(acess_token)
    response = @service.get_user_info(acess_token, Directory::USER_TERMINAL_INFO)
    assert_equal response.size, 1
    assert_equal response.include?("userTerminalInfo"), true
    assert_equal response["userTerminalInfo"].size >= 1, true
    assert_equal response["userTerminalInfo"].include?("version"), true
  end

  def get_access_info(acess_token)
    response = @service.get_user_info(acess_token, Directory::USER_ACCESS_INFO)
    assert_equal response.size, 1
    assert_equal response.include?("userAccessInfo"), true
    assert_equal response["userAccessInfo"].size >= 1, true
    %W[apn].each { |key|
      assert_equal response["userAccessInfo"].include?(key), true
    }
  end

  def get_profile(acess_token)
    response = @service.get_user_info(acess_token, Directory::USER_PROFILE)
    assert_equal response.size, 1
    assert_equal response.include?("userProfile"), true
    %W[userType icb ocb parentalControl operatorId segment].each { |key|
      assert_equal response["userProfile"].include?(key), true
    }
  end

  def get_profile_access_info(acess_token)
    response = @service.get_user_info(acess_token, [Directory::USER_ACCESS_INFO, Directory::USER_PROFILE])

    assert_equal response.size >= 1
    
    %w[userAccessInfo].each{|key|
      assert_equal true, response.has_key?(key)
    }

    %W[apn].each { |key|
      assert_equal response["userAccessInfo"].include?(key), true
    }
  end

  def get_all_info(acess_token)
    response = @service.get_user_info(acess_token)
    assert_equal response.size, 1
    assert_equal response.include?("userInfo"), true
    assert_equal response["userInfo"].size >= 2

    [ "userAccessInfo",
      "userProfile"].each {
      |key|
      assert_equal response["userInfo"].include?(key), true
    }
  end

end
