#
# BlueVia is a global iniciative of Telefonica delivered by Movistar and O2.
# Please, check out www.bluevia.com and if you need more information
# contact us at mailto:support@bluevia.com

$:.unshift File.join(File.dirname(__FILE__),'..','lib')

require 'test/unit'
require 'bluevia'
require 'test_config'

#
# (c) Bluevia (mailto:support@bluevia.com)
#

class TestOauth < Test::Unit::TestCase
  include TestConfig
  def setup
    create_client(false, :oAuth)
  end

  def test_get_request_token_callback
    token, secret, url = @service.get_request_token({:callback =>"http://foo.bar"})
    p url
    assert_not_nil token
    assert_not_nil secret
    assert_not_nil url
  end

  def test_get_request_token_callback_uri
    token, secret, url = @service.get_request_token({:callback =>"http://foo.bar", :uri => TestConfig::SandBox::AUTHORIZE_URI})
    p url
    assert_not_nil token
    assert_not_nil secret
    assert_not_nil url
  end

  def test_get_request_token_nickname
    token, secret, url = @service.get_request_token({:nickname =>"juansdp7"})
    p token
    p secret
    p url
    assert_not_nil token
    assert_not_nil secret
    assert_not_nil url
  end

   def ftest_get_request_token_invalid
    assert_raise SyntaxError do
      @service.get_request_token({:nicknam =>"juandebravo"})
    end
  end

  def ftest_get_request_token_commercial
    create_client(true, :oAuth)
    token, secret, url = @service.get_request_token("http://foo.bar")
    p token
    p secret
    p url
  end

  def ftest_get_access_token
    create_client(true, :oAuth)

    token = "20100728102227000020"
    secret = "f8e12e97c4ee785bab418ed0f68df623"

    result1, result2 = @service.get_access_token(token, secret, "529fa27d6bbb8565add26600137294b7")
    p result1
    p result2
  end
end
