#
# BlueVia is a global iniciative of Telefonica delivered by Movistar and O2.
# Please, check out www.bluevia.com and if you need more information
# contact us at mailto:support@bluevia.com

$:.unshift File.join(File.dirname(__FILE__),'..','lib')

require 'test/unit'
require 'bluevia'
require 'test_config'

#
# (c) Bluevia (mailto:support@bluevia.com)
#

class TestSms < Test::Unit::TestCase
  include TestConfig

  def setup
    create_client(false, :Sms)
  end

  # 
  # Validates the SMS MO Get Received Message
  #
  def t_test_get_received_sms
    create_sms_mo
    get_received_sms(TestConfig::SandBox::SMS_REGISTRATION_ID, 1)
  end

  #
  # Validates the SMS MO Get Received Message
  #
  def t_test_get_received_sms_multiple
    (1..5).each{
      create_sms_mo
    }
    get_received_sms(TestConfig::SandBox::SMS_REGISTRATION_ID, 5)
  end
  #
  # Validates the SMS MO Get Received Message with an invalid Registration ID
  #
  def t_test_get_received_sms_fails
    get_received_sms_fails
  end

  private

  def get_correlator_id
    (0...10).map{ ('a'..'z').to_a[rand(26)] }.join
  end

  def create_sms_mo
    @service.send_sms(TestConfig::SandBox::SMS_SPECIAL_NUMBER, 
                      TestConfig::SandBox::TOKEN,
                      "#{TestConfig::SandBox::SMS_SPECIAL_KEYWORD} Yet another SMS Text")
  end



  def get_received_sms(registration_id, number = 0)
    info = @service.get_received_sms(registration_id)
    p info.length
    assert_equal info.length >= number, true
    ["originAddress", "dateTime", "destinationAddress", "message"].each {
      |key|
      assert_equal info[0].include?(key), true
    }
    p info[0]["message"]
  end

  def get_received_sms_fails
    assert_raise RuntimeError do
      @service.get_received_sms("352342641")
    end
  end

end
